;;;;;;;;;;;;;; TEST of adjfrac ;;;;;;;;;;;;;

;;;;; 1) Two examples not needing homogenization:
;;;;;;;;;; a) Normalization of the cuspidal cubic

ring r
;
2
ab
2 3
;

ideal m
1
a3-b2
qring m r

poly amat a
poly i b
type amat
; should be "a"
type i
; should be "b"

<ring 1 x S
ring-sum r S S
pring S

<adjfrac
<adjfrac amat i n
type n
; should be: "a-x2  b-x3"

kill r'zero r m amat i S'zero S n
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;; b) Normalization of the smooth rational quartic

<ring 4 a-d r
<monomcur 1 3 4 i
std i i
qring i R

; The variable a represents s4, while b represents s3t, so b2/a = s2t2,
; the missing generator.
poly num b2
poly denom a

;Set up the ring for the output:
<ring 1 x S0
ring-sum R S0 S

;Now adjoin b2/a:
setring S
<adjfrac denom num K
std K K
betti K
; Note that K has only 5 generators:
; the sixth is in the defining ideal of S!

present-ring S L
fetch K K1
concat L K1
nres L L
betti L
; The ideal of the rational normal quartic! It should be:
; total:      1     6     8     3
; --------------------------------
;     0:      1     -     -     -
;     1:      -     6     8     3

kill r'zero r i R'zero R num denom S0'zero S0 S'zero S K L K1
; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;; 2) Examples needing homogenization:

;;;;;;;;;; a) Affine open in a blowup:  k[x,y,x/y]

<ring 2 xy r
poly Y y
<ideal J x
<ring 3 xyz S
<adjfrac Y J K
type K
; should be "yz-x"

kill r'zero r Y J S'zero S K
; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;; b) Normalization of two skew lines in P3:

<ring 4 a-z P3
<ideal l1 a b
<ideal l2 c d
intersect l1 l2 i
qring i q
<ideal denom a+c
<ideal num a
<ring 1 e S1
ring-sum q S1 S
<adjfrac denom num K
type K
; should be: "e2-e  de  ce  be-b  ae-a"

listvars
;;;;;;;;;;;;;;;;;;; END test of adjfrac ;;;;;;;;;;;;;;
reset
$

