;;;;;;;;;;;;;;;;;; TEST of analyspr ;;;;;;;;;;;;;;;;;;

;;; 1) A complete intersection has an. spread equal to its codimension:

<ring 4 a-z r
<analyspr
<analyspr r s
type s
; should be "4"

setring r
<ideal i a3 b4
<analyspr i
; should be "2"

kill r'zero r s i

;;; 2) Determinantal examples:

; a) For the maximal minors of the generic p x q matrix,
;    the analytic spread is the affine dimension of the
;    Grassmannian of p-planes in q-space,
;    that is p(q-p)+1.

; First a case where the catalecticant matrix
; has the same analytic spread as the generic matrix:

<ring 5 a-z r
cat a m
0 1
0..3
type m
; correct answer:
; a b c d
; b c d e

wedge m 2 m2
<analyspr m2
; should be "5"

kill r'zero r m m2

; b) In general the minors of the catalecticant matrix have smaller
;    analytic spread than those of the generic matrix.
;    What are these analytic spreads??

<ring 18 a-z r
<genermat a 3 6 m
type m
; should be:
; a b c d e f
; g h i j k l
; m n o p q r

wedge m 3 m3
; the following takes a couple of minutes:
<analyspr m3
; should be "10"
; This is the correct answer, gotten by knowing that
; one could stop the computation in the blowup step after degree 8.

listvars
;;;;;;;;;;;;;;;;;;; END test of analyspr ;;;;;;;;;;;;;;;;;;;;;;;
reset
$

