;;;;;;;;;;;; TEST of curoncub ;;;;;;;;;;;

<ring 3 a-z P2
<ring 4 a-z P3

setring P2

;Make the matrix of points:
<ideal p1 1 -1 2
<ideal p2 1 2 3
transpose p1 p1
transpose p2 p2
copy p1 p
concat p p2
type p

;a plane curve:
setring P2
<ideal C1 3a+4b+5c ;line not through any point
<ideal C2 a ;line through 2 points
<ideal C3 b+5a ;line through one of thepoints
<ideal zero
setring P3

<curoncub p C1 I
nres I I
betti I
; should be:
; total:      1     3     2
; --------------------------
;     0:      1     -     -
;     1:      -     3     2
;twisted cubic

<curoncub p C2 I
nres I I
betti I
; should be:
; total:      1     2     1
; --------------------------
;     0:      1     2     1
;line

<curoncub p C3 I
nres I I
betti I
; should be:
; total:      1     2     1
; --------------------------
;     0:      1     1     -
;     1:      -     1     1
;plane conic in P3.

<curoncub p zero cubic
type cubic

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;The cases of degenerate point sets:
<ring 3 a-z P2
<ring 4 a-z P3

setring P2

<ideal C1 3a+4b+5c

;three points on a line:
<ideal p1 1 -1 0
<ideal p2 1 2 3
transpose p1 p1
transpose p2 p2
copy p1 p
concat p p2
type p

setring P3
<curoncub p C1 I
nres I I
betti I

;6 points on a conic xy+xz-2yz.
;If x=1, such points are given by z = 1/(2-(1/y)):
<ring 3 a-z P2
<ring 4 a-z P3

setring P2

<ideal C1 3a+4b+5c
<ideal p1 1 2 2/3
<ideal p2 1 3 3/5
transpose p1 p1
transpose p2 p2
copy p1 p
concat p p2
type p

setring P3
<curoncub p C1 I
nres I I
betti I
;A plane cubic in this case

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<ring 3 a-z P2
<ring 4 a-z P3
setring P2

;A curve in the class |d L - d1 L1 - ... - d6 L6|
;on the cubic surface. The result has
;    degree = 3d - \sum di
;    genus = (d-1)(d-2)/2  - \sum di(di-1)/2
<ideal mults a a a2 a3 a4 a5 ;these are of degree d1 .. d6

;Make the matrix of points:
<ideal p1 1 -1 2
<ideal p2 1 2 3
transpose p1 p1
transpose p2 p2
copy p1 p
concat p p2

;The full matrix of points:
iden 3 points
<ideal ones 1 1 1
transpose ones ones
concat points ones
concat points p
;Now make the ideal of points with multiplicities:
<points points candidates mults

betti candidates
;use this to decide what degree d to take:
int d 8 ;This gives an elliptic octic.
;(this only matters, as far as the betti numbers go, mod 3.)

res candidates candidates
k-basis candidates.2 cand
d
d
mult candidates.1 cand cand
type cand

<randomat 1 1 cand C

setring P3

<curoncub p C I
nres I I
betti I
; should be:
; total:      1     8    11     4
; --------------------------------
;     0:      1     -     -     -
;     1:      -     -     -     -
;     2:      -     1     -     -
;     3:      -     -     -     -
;     4:      -     6     9     3
;     5:      -     1     2     1
hilb I.1
; should be:
; codimension = 2
; degree      = 8
; genus       = 1

listvars
;;;;;;;;;;;;;;;; END test of curoncub ;;;;;;;;;;;;
reset
$




