;;;;;;;;;;;;;;;;;;;; TEST of dualvar ;;;;;;;;;;;;;;;;;;;

; I) Duality in the plane:

ring r
;
3
a-z
;
;
;
;Use the above ring for the following examples:

; a) The nonsingular cubic

poly f1 a3+b3+c3
<dualvar
<dualvar f1 1 j
type j
<dualvar j 1 i
type i

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; b) The cuspidal cubic:
poly f a2c-b3
<dualvar f1 1 j
type j

<dualvar j 1 i
type i

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; c) The nodal cubic:
poly f a2c-b3-b2c

<dualvar f1 1 j
type j

<dualvar j 1 i
type i

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; d) The nonsingular quartic
poly f1 a4+b4+c4

<dualvar f1 1 j
type j

<dualvar j 1 i
type i

;Note -- If one tries the sextic, the second computation,
;starting from a curve of degree 30, quickly exceeds the
;monomial degree bound (in a call to sat1,
;in the first set of vars, I think).

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; II) Duality in 3-space
ring r
;
4
a-z
;
;

; a) The twisted cubic

cat a i
0 1
0 1 2
wedge i 2 i
flatten i i

<dualvar i 2 j
type j
; should be: b2c2-4ac3-4b3d+18abcd-27a2d2

<dualvar j 1 i1
type i1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; b) The elliptic quartic

ideal i
2
ab-cd
a2+b2+c2-d2

;test for nonsingularity
jacob i ii
wedge ii 2 ii
flatten ii ii
concat ii i
std ii ii
codim ii
;should be: 4--so its nonsingular

; The following example takes very long. Run it only if you have lots
; of time amd memory.
;<dualvar i 2 j
;type j

;<dualvar j 1 i1
;type i1

listvars
;;;;;;;;;;;;;;;;;;;; END test of dualvar ;;;;;;;;;;;;;;;;;
reset
$


