;;;;;;;;;;;;;;;;;;;;; TEST of normalco ;;;;;;;;;;;;;;;;;

; The normal cone of the rational normal quartic curve in P4:
; Note that the normal cone has an embedded component at the max ideal.
; In fact, since the ideal, j,  of the normal quartic is generated by the
; 2x2 minors of a 3x3 matrix (m below), the symbolic square of j contains
; det m, which then appears as an extra quadratic form in (l : (a,b,c,d,e)),
; where l is the ideal of the normal cone.

<ring 5 a-e r

cat a m
    0 1 2
    0 1 2

; the ideal of the rational quartic is generated by the 2x2 minors of m
wedge m 2 m2
flatten m2 j
std j j

; we know that j has 6 minimal generators of degree 2
<ring 6 u-z s
ring-sum r s t

<normalco
<normalco j t l

type l
std l ll
degree ll
fetch r max
quotient ll max lsat
numinfo ll
numinfo lsat

listvars
;;;;;;;;;;;;;;;;;;; END test of normalco ;;;;;;;;;;;;;;;;;;
reset
$


