;;;;;;;;;;;;;;;;;;;;;; TEST of sat ;;;;;;;;;;;;;;;;;;;

<ring 3 a-z r
<ideal A a2 ab ac bc
<ideal f a+b+c

<sat
<sat A r L
;takes 1.5 sec
type A
std L L
type L
;should be: a bc
kill L

<sat A r L it
;takes <1 sec
type A
type L

; A harder case:
<ring 3 a-z r
<ideal A a2 ab ac bc
power A 10 A

<sat A r L   ;takes 1min, 5 sec
type A
std L L
type L
;should be: a bc
kill L

<sat A r L it  ;takes 55 sec
type A
type L

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

<ring 5 a-z r
cat 0 m
0 1
0..3
wedge m 2 m2
;A perfect ideal (saturated with resp to r)
betti m2
; correct answer:
; total:      1     6
; --------------------
;     0:      1     -
;     1:      -     6

power r 2 P
transpose P P'
mult P' m2 prod
betti prod
flatten prod prod
;Prod is m2 times the ideal of quadrics
<sat prod r tellus    ;remove the ideal of quadrics ;takes 7 sec
std tellus tellus
betti tellus
; correct answer:
; total:      1     6
; --------------------
;     0:      1     -
;     1:      -     6

kill tellus
<sat prod r tellus it    ;takes 24 sec
betti tellus

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Computing the dual of a plane curve f=0: (see the script dualvar
;for an automated version.)

;The ring of P2xP2

ring r
 ;
 6
 abcxyz
 ;
 3 3

poly f b2c-a2(a-c) ;the nodal cubic
type f
jacob f j
type j
transpose j j'

;form the row of variables of the second factor
<getvars vars
elim vars vars2

;Now form the graph of the Gauss map
transpose vars2 vars2'
concat j' vars2'
wedge j' 2 i
flatten i i
concat i f
type i
type j

;Remove the components coming from the singular locus
<sat i j k
std k k
;<4 sec for the sat, about 8 with the following std (built in with it)
type k
kill k

<sat i j k it   ;takes 16 sec
type k
betti i
betti j
quotient i j k

;and project
<ring 3 x[1]-x[3] s
<projprod k 3 k1
type k1
; correct answer:
; x[1]4+2x[1]2x[2]2+x[2]4+x[1]3x[3]+9x[1]x[2]2x[3]+27/4x[2]2x[3]2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;An example where i is not an ideal, to see if all the conditionals work:

<ring 3 a-z r
<ideal i ab ac bc
dsum i i m
type m
poly f a
<sat1 m f n
type n

<sat m f n
type n
<sat m f n it
type n

listvars
;;;;;;;;;;;;;;;;;;;;;;; END test of sat ;;;;;;;;;;;;;;;;;;;;;;;;;;
reset
$


